{
(c)2001 by Marc Le Meur

edit an IP address:

  Licensing: Use however you want but don't erase this header.
  Please tell me where you use it (location and use of program).
  If you fix bugs or add nifty features, please let me know.
	marc.le.meur@libertysurf.fr
  If you earn money with it, please mention me.

  Please visit : www.mostwantedvideos.com

  I WILL NOT ASSUME ANY RESPONSIBILITY WHATSOEVER FOR ANY DAMAGES RESULTING
  FROM THE USE/MISUSE OF THIS UNIT. Use at your own risk.
}
unit Unit_IPEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type

	TIPEdit =  class(TMaskEdit)
	protected
		procedure KeyDown(var Key: Word; Shift: TShiftState); override;
	private
		procedure CMExit(var Message: TCMExit);   message CM_EXIT;
		procedure ModifieQuartet(sQuartet : string; nPosQuartet, nPosDansQuartet : integer; Key : word);
	public
		constructor Create(AOwner: TComponent); override;
		function bIPValid():Boolean;

	end;

procedure Register;

implementation
{***************************************************************************
***************************************************************************}
procedure TIPEdit.CMExit(var Message: TCMExit);
begin
//	if not IPCorrecte() then
//		ShowMessage('err');
end;
{***************************************************************************
***************************************************************************}
constructor TIPEdit.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	EditMask :='999.999.999.999;1; ';
end;

{***************************************************************************
***************************************************************************}
procedure TIPEdit.KeyDown(var Key: Word; Shift: TShiftState);
var
	i		: integer;
	nPos	: integer;
	nSel	: integer;
	nStart	: integer;
	sPrevText : string;
begin
  //	SelLength := 1;
	//-------------------------------------------------------
	{dplacement droite et gauche:
	}
	if (Key=VK_RIGHT) AND (Shift=[]) then
	begin
		SelLength	:=1;
		nStart 		:= selstart;
		sPrevText	:= SelText;

		for i:=nStart+1 to 15 do
		begin
			selstart := i;
			SelLength:= 1;

			//si on a 2 espaces conscutifs au dbut on s'arrte au second
			if  (seltext=' ') and (sPrevText<>' ') and (i=nStart+1) then
				break;

			//on saute les espaces et les .
			if (seltext<>' ') and (seltext<>'.') then
				break;

		end;

		//si on a 2 espaces conscutifs on recule de 1 pour aller sur le second
		if  (seltext<>' ') and (sPrevText<>' ') and (i=nStart+1) then
			selstart := i-1
		else
			selstart := i;

		//slectionne 1 car
		SelLength:= 1;
		Key := 0;
	end
	//-------------------------------------------------------
	else if (Key=VK_LEFT) AND (Shift=[]) then
	begin
		SelLength:=1;
		nStart := selstart;
		sPrevText := SelText;

		for i:=nStart-1 downto 0 do
		begin
			selstart := i;
			SelLength:= 1;

			//si on a 2 espaces conscutifs au dbut on s'arrte au second
			if  (seltext=' ') and (sPrevText<>' ') and (i=nStart-1) then
				break;

			//on saute les espaces et les .
			if (seltext<>' ') and (seltext<>'.') then
				break;

		end;
		//si on a 2 espaces conscutifs on recule de 1 pour aller sur le second
		if  (seltext<>' ') and (sPrevText<>' ') and (i=nStart+1) then
			selstart := i+1
		else
			selstart := i;

		SelLength:= 1;
		Key := 0;
	end
	//-------------------------------------------------------
	else if ( (Key=VK_SPACE) OR (Key=VK_DELETE) OR (Key=VK_BACK)) AND (Shift=[]) then
	begin
		if (Key=VK_BACK) then
			SelStart := SelStart - 1;

		nSel := SelLength;
		if SelLength=0 then
			nSel:=1;

		if nSel>1 then
		begin
			// on veut effacer plx car slectionns
			SelLength	:= 1;
			nStart		:= SelStart;
			for nPos:=nStart to nStart+nSel-1 do
			begin
				SelStart := nPos;
				SelLength := 1;
				if (SelText<>'.') then
					SelText := ' ';
			end;
		end
		else
		begin
			// on efface 1 seul car
			if (SelText='.') then
				if (Key=VK_BACK) then
					SelStart := SelStart - 1
				else
					SelStart := SelStart + 1;

			if SelLength=0 then
				SelLength:=1;

			if (SelText<>'.') then
			begin
				SelText := ' ';

			//si backspace on recule
			if (Key=VK_BACK) then
				SelStart := SelStart - 1;
			end;
		end;
		Key := 0;
	end;

	//-------------------------------------------------------
	if (((Key>=$30) AND (Key<=$39)) OR
		((Key>=VK_NUMPAD0) AND (Key<=VK_NUMPAD9))) then
	begin
		if (Key>=VK_NUMPAD0) AND (Key<=VK_NUMPAD9) then
			Key := Key+$30-VK_NUMPAD0;

		nSel := SelLength;
		if nSel>1 then
		begin
			// on a slectionn plx car , on efface toute la slection saut le
			//premier car qui est remplac par Key 
			nStart	:= SelStart;
			for nPos:=nStart to nStart+nSel-1 do
			begin
				SelStart := nPos;
				SelLength	:= 1;

				if nPos=0 then
					SelText := chr(Key)
				else if nPos mod 4 = 3 then
					SelText := '.'
				else
					SelText := ' ';
			end;
			SelStart := nStart;
		end;

		if SelLength=0 then
			SelLength:=1;

		// analyse des donnes pour viter de dpasser 255
		nPos := SelStart - Selstart mod 4;

		ModifieQuartet(copy(text, nPos+1,3) , nPos, (Selstart mod 4) +1, Key );

	end;
	//-------------------------------------------------------

end;

{***************************************************************************
nPosDansQuartet : 1->3
***************************************************************************}
procedure TIPEdit.ModifieQuartet(sQuartet : string; nPosQuartet, nPosDansQuartet : integer; Key : word);
var
	sTmp			: string;
	nValeur, nCode	: integer;
	nPos	        : integer;
	nSel	        : integer;
	nStart	        : integer;
begin
	sTmp := sQuartet ;
	sTmp[nPosDansQuartet] := chr(Key);
	sTmp := Trim(sTmp);

	Val(sTmp, nValeur, nCode);

	if (nCode=0) AND (nValeur<255) then
		Exit;

	// on va corriger l'adresse comme un grand
//	OutputDebugString(PChar(sTmp));


	nSel       := SelLength;
	nStart     := SelStart;

	for nPos:=nPosQuartet to nPosQuartet+3 do
	begin
		SelStart 	:= nPos;
		SelLength	:= 1;
		
		case (nPos-nPosQuartet) of
		0: SelText := '2';
		1: SelText := '5';
		2: SelText := '4';
		end;
	end;

end;

{******************************************************************************
Vrification du de la zone IP
******************************************************************************}
function TIPEdit.bIPValid():Boolean;
var
	Valeur		: integer;
	Code		: integer;
	Cpt			: integer;
	Octet		: string;
begin

	result := TRUE;

	for Cpt:=0 to 3 do
	begin
		Octet := copy(text, Cpt*4+1,3);
		Octet := Trim(Octet);

		if Octet<>'' then
		begin
			val(Octet, Valeur, Code);

			if (Code<>0) or (Valeur>=255) then
			begin
				result := FALSE;
				break;
			end
		end;
	end;
end;

{***************************************************************************
***************************************************************************}
procedure Register;
begin
  RegisterComponents('Divers', [TIPEdit]);
end;         {register}

{***************************************************************************
***************************************************************************}
end.
